%module cpptest
%{
#define SWIG_FILE_WITH_INIT
#include "tasks.h"
#include "schedulability.h"
#include "edf/baker.h"
#include "edf/gfb.h"
#include "edf/baruah.h"
#include "edf/bcl.h"
#include "edf/bcl_iterative.h"
#include "edf/rta.h"
#include "edf/ffdbf.h"
#include "edf/load.h"
#include "edf/gedf.h"
#include "edf/sim.h"
#include "sharedres.h"
%}

%ignore Task::get_utilization(mpq_class &util) const;
%ignore Task::get_density(mpq_class &density) const;
%ignore Task::bound_demand(const mpz_class &time, mpz_class &demand) const;
%ignore Task::bound_load const;
%ignore Task::approx_demand const;

%ignore TaskSet::get_utilization const;
%ignore TaskSet::get_density const;
%ignore TaskSet::get_max_density const;
%ignore TaskSet::approx_load const;

#include "tasks.h"
#include "schedulability.h"
#include "edf/baker.h"
#include "edf/gfb.h"
#include "edf/baruah.h"
#include "edf/bcl.h"
#include "edf/bcl_iterative.h"
#include "edf/rta.h"
#include "edf/ffdbf.h"
#include "edf/load.h"
#include "edf/gedf.h"
#include "edf/sim.h"

%newobject task_fair_mutex_bounds;
%newobject task_fair_rw_bounds;
%newobject phase_fair_rw_bounds;

%newobject global_omlp_bounds;
%newobject global_fmlp_bounds;
%newobject part_omlp_bounds;
%newobject clustered_omlp_bounds;
%newobject clustered_rw_omlp_bounds;

%newobject part_fmlp_bounds;
%newobject mpcp_bounds;
%newobject dpcp_bounds;

%ignore Interference;
%ignore RequestBound;
%ignore TaskInfo;

%ignore ResourceSharingInfo::get_tasks;

%ignore BlockingBounds::raise_request_span;
%ignore BlockingBounds::get_max_request_span;

#include "sharedres.h"

