from util import sec2us

try:
    import cpptest as cpp

    using_cpp = True

    def misses_deadline(no_cpus, tasks, simulation_length=60):
        fts = tasks.as_cpp_taskset()
        return cpp.edf_misses_deadline(no_cpus, fts, sec2us(simulation_length))

    def first_violation(no_cpus, tasks, simulation_length=60):
        fts = tasks.as_cpp_taskset()
        return cpp.edf_first_violation(no_cpus, fts, sec2us(simulation_length))

except ImportError:
    # Nope, C++ impl. not available. Use Python implementation.
    using_cpp = False

    def misses_deadline(*args, **kargs):
        return False # no Python implementation available

    def first_violation(*args, **kargs):
        return 0

def no_counter_example(*args, **kargs):
    return not misses_deadline(*args, **kargs)
