#!/usr/bin/env python

import sys

from gedf import TESTS
from model.serialize import load

def test_and_report(fname, num_procs):
    ts = load(fname)
    ts.make_integral()

    print '-' * 40
    print 'Taskset: %s' % fname
    print 'Utilization: %.2f' % ts.utilization()
    print 'Density: %.2f' % ts.density()
    for test in sorted(TESTS.keys()):
        print '\t%6s -> ' % test,
        sys.stdout.flush()
        ok = TESTS[test](num_procs, ts)
        print ok

if __name__ == '__main__':
    for fname in sys.argv[1:]:
        test_and_report(fname, 2)
