# hackish git 'interface'

import re
import os

from subprocess import Popen, PIPE

def get_this_repo():
    return os.path.abspath(os.path.join(os.path.dirname(__file__), '..'))

def git_current_head(repo_dir=None):
    if repo_dir is None:
        repo_dir = get_this_repo()
    try:
        head_file = open(repo_dir + '/.git/HEAD')
        ref_str = head_file.readline()
        head_file.close()
    except IOError, msg:
        return None
    parsed = re.match('ref: ([^\n]*)\n', ref_str)
    if not parsed:
        return None
    try:
        ref_file = open(repo_dir + '/.git/' + parsed.group(1))
        sha      = ref_file.readline()
        ref_file.close()
    except IOError, msg:
        return None
    return sha.strip()

def git_locally_modified(repo_dir=None):
    "Limitation: Assumes CWD is a git directory."
    if repo_dir is None:
        repo_dir = get_this_repo() + '/.git'
    try:
        env = dict(os.environ)
        env['GIT_DIR'] = repo_dir
        git = Popen(['git', 'diff', '--name-only'],
                    env=env, stdout=PIPE)
        (out, err) = git.communicate()
    except OSError, msg:
        print 'git_locally_modified(): ', msg
        return None
    files = out.strip()
    return files.split('\n') if files else []

